import es


info = es.AddonInfo()
info['name']        = "TFlash"
info['version']     = "1.3P"
info['author']      = "*XYZ*SaYnt"
info['url']         = "http://cans-crew.com"
info['description'] = "Detects team flashes and reports all flash stats for logging"


  
def config():
   #duration of a flash under which a player is not considered blind.
   #in seconds.
   global TF_DURATIONLIMIT 
   
   TF_DURATIONLIMIT = 0.75


 
def load():
    TF_VERSION = "1.4P"
    config()
    es.msg("TFlash " + TF_VERSION + " by *XYZ*SaYnt loaded.")

    global flashed_for
    flashed_for = {}
    
    global log_events
    log_events = []


#This is our custom version of statlog until the python version comes out.
def statlog(userid,event):
    es.server.queuecmd("statlog " + str(userid) + " " + event)
  
##############################################################################
#ASSUMPTION.....FLASHBANG DETONATE HAPPENS VERY QUICKLY AFTER PLAYER BLIND.
##############################################################################

def player_blind(ev):
   userid = int(ev['userid'])
   log_events.append([userid,"Player_Blind"])
   
   #add blinded players to a dictionary; userid is the key; store the
   #flash duration.
   #and only store if flash magnitude is high (255)
   isdead = int(es.getplayerprop(userid,"CCSPlayer.baseclass.pl.deadflag"))
   if not isdead:  
       alpha = int(es.getplayerprop(userid,"CCSPlayer.m_flFlashMaxAlpha"))
       if alpha == 255:
           duration = float(es.getplayerprop(userid,"CCSPlayer.m_flFlashDuration"))
           if duration > TF_DURATIONLIMIT:
               flashed_for[userid] = duration 



def flashbang_detonate(ev):
    userid = int(ev['userid'])
    log_events.append([userid,"Flash_Detonate"])

    #we already have a list of players that were just blinded, so we loop through
    #that list and see if any were on our team.
    for k, v in flashed_for.iteritems():
       userteam = int(ev['es_userteam'])
       tfcheck(userid,userteam,k,v)

    # now clear out the dictionaries that we have created
    flashed_for.clear()



def tfcheck(userid_of_flasher,team_of_flasher,userid_of_flashed,duration):
    team_of_flashed = int(es.getplayerteam(userid_of_flashed))
    if team_of_flasher == team_of_flashed: 
        if userid_of_flasher == userid_of_flashed:
            # player flashed himself.
	          es.tell(userid_of_flashed,"[FT] You just flashed yourself for " + str(duration) + " seconds.")
	          log_events.append([userid_of_flashed,"Self_Flasher"])
        else:
            # player flashed a teammate. tattle.
            blinded_name = es.getplayername(userid_of_flashed)
            flasher_name = es.getplayername(userid_of_flasher)
            es.tell(userid_of_flashed,"[FT] You were just teamflashed for " + str(duration) + " seconds by " + flasher_name)
            es.tell(userid_of_flasher,"[FT] You just teamflashed " + blinded_name + " for " + str(duration) + " seconds.")
            log_events.append([userid_of_flasher,"Team_Flasher"])
            log_events.append([userid_of_flashed,"Team_Flashee"])
            
    else:
        # player flashed the opposite team, which is good.
        log_events.append([userid_of_flasher,"OppositeTeam_Flasher"])


def round_end(ev):
    # at round end, we dump the stats.  This is for efficiency so that we are not
    # calling statslog quite so much during the middle of gameplay.  I've never
    # seen a problem with doing this, but still, it pays to be efficient.
    for x in log_events:
        statlog(x[0],x[1])
    del log_events[:]
    
